首页   注册   登录
V2EX = way to explore
V2EX 是一个关于分享和探索的地方
现在注册
已注册用户请  登录
拉勾
V2EX  ›  Android

怎么禁止/屏蔽/绕过 APP 强制更新才能用?

  •  
  •   cantonadong · 2018-01-23 11:12:46 +08:00 · 11552 次点击
    这是一个创建于 421 天前的主题,其中的信息可能已经有所发展或是发生改变。

    今天京东强制要求更新,不更新不能用,只能点升级或退出。 有这么流氓的吗?

    怎么能够跳过这个机制?

    31 回复  |  直到 2018-01-27 23:53:53 +08:00
        1
    honeycomb   2018-01-23 11:23:02 +08:00 via Android
    这个一般很难,可能涉及到修改客户端

    建议不再使用 app 端,而使用网页版,如果无论如何也不愿意接受它的强迫升级。
        2
    liuzhedash   2018-01-23 11:24:45 +08:00
    这不可能。。。
        3
    hqfzone   2018-01-23 11:26:42 +08:00   ♥ 1
    强制升级可能是因为以后数据接口都变了,你即使绕过了……又如何?
        4
    1115746521   2018-01-23 11:43:48 +08:00
    https://www.imooc.com/article/9681
    只用 fiddler 的修改 response 方法进行修改,但是每次打开 app 就得修改
        5
    yuriko   2018-01-23 12:17:22 +08:00   ♥ 2
    话说,不就是因为后台数据接口有不兼容的地方才强制更新么……
        6
    kslr   2018-01-23 12:34:58 +08:00   ♥ 1
    作为开发者,一般很少要求强制升级,除非是影响到用户使用的问题才会强制升级。
        7
    zj299792458   2018-01-23 12:39:17 +08:00 via iPhone   ♥ 3
    自己搭一个老的 jd 服务器配合即可
        8
    meisky6666   2018-01-23 12:41:02 +08:00 via Android
    host 屏蔽?
        9
    kingboy9525   2018-01-23 12:52:51 +08:00
    用小程序?
        10
    Jameson1559   2018-01-23 15:05:16 +08:00   ♥ 1
    以我目前接手项目为例

    之前一直没有强制更新功能,但是后来服务端配置和接口发生几次大的更新,其中有几个接口结果集发生了不兼容的变更,询问过项目经理,领导沟通一致之后决定不做接口过渡(也就是没有备用接口),然后,很自然的导致了一大批闪退报错问题,查看一下活跃用户版本发现好多用户停留在 build 71,目前正式构建号 80,不兼容更新是构建 75,然后这批用户就抱团报问题,说:你看我们这个!都用不成了!你们开发组的在吃 S 吗?给我们项目经理还一顿批,更搞笑的是有的人构建号还是 25,也凑热闹……最后解决方案很简单,自己更新,更新到最新版本之后什么问题都没有。

    该更新就更新,你不是开发这个产品的,你不会知道更新背后的变动有多大的,如果你愿意死守老版本,就要做好没有技术支持的准备,开发人员不会因为你版本停在 25 就返回过去给你一个人专门提供 25 版本的接口和维护的。不愿意更新但却想要享受最新版的功能这事儿基本上是不可能的

    如果坚持不愿意更新(就像是死守 Win Xp,宁死不更 Win 10 ),请自己构建并搭设应用所需要的全部服务接口

    「或者换成 Web 版本,不要使用 App 」(如果有 Web 版本的话)
        11
    EmmaSwan   2018-01-23 15:06:11 +08:00
    那我要是流量差不多到头了,还得花个几十上百兆去下载?
    脑回路无法理解
        12
    strongcoder   2018-01-23 15:14:02 +08:00
    强更 很正常 我开发 APP 过程中经历过三次强更 没有问题谁愿意强更,每次推行强制更新都会有很多咨询电话过来 一般都是 APP store 的锅 什么 刷新不出来新版本 一直在应用和 APP Store 跳来跳去,至于楼上说什么流量问题 搞笑了吧 都设置强更了 还管你啥流量啊 没流量不用 卸载
        13
    s82kd92l   2018-01-23 15:18:59 +08:00
    BAT 巨头们玩热更新还要更恶心,需要消耗更多流量和存储空间。 只要 app 更新时没要新权限,我觉得都可以接受。你用 web 版或者小程序,每一次使用也会自动加载最新版本,效果一样的。

    @EmmaSwan 比如酷安就有增量更新,可以省不少流量。
        14
    EmmaSwan   2018-01-23 15:30:57 +08:00
    @strongcoder 不好笑.
        15
    luojianxhlxt   2018-01-23 15:35:23 +08:00 via iPhone
    xp 框架有个取消对话框的插件
        16
    qianmeng   2018-01-23 15:38:55 +08:00 via Android
    @honeycomb 这个要说知乎了,手机网页版设置障碍,千方百计跳到客户端,这年头防不胜防。
        17
    learnshare   2018-01-23 15:39:49 +08:00
    开发商通常希望用户手里统一只有最新版,两个版本之间是否可以兼容都是不能保证的
        18
    HongJay   2018-01-23 15:51:42 +08:00
    @strongcoder 只有开发者能理解开发者。。
        19
    zsdroid   2018-01-23 15:55:43 +08:00
    @EmmaSwan 流量差不多到头了,还上啥网,而且现在大街上各种 wifi
        20
    WillBe   2018-01-23 16:12:11 +08:00
    我 相信所有的强更都是开发者不得已的决定。
        21
    WillBe   2018-01-23 16:13:52 +08:00
    接上,要不是数据、接口无法再兼容,要不就是产品 /市场为强推某功能强制要求(此条是恶心之根源)
        22
    l12ab   2018-01-23 16:28:13 +08:00 via iPhone
    我的做法是,几个主要的旧接口保留,但是不在返回内容,而是返回升级提示
        23
    dd1982cn   2018-01-23 16:38:15 +08:00 via iPhone
    京东真心恶心 我也提示了 不更新直接强退
        24
    honeycomb   2018-01-23 17:00:20 +08:00
    @qianmeng 知乎这种总是有办法绕,除非它关闭网页的移动端
        25
    syuraking   2018-01-23 17:44:34 +08:00
    用谷歌版本啊……没自动更新……
        26
    JackYao   2018-01-23 17:47:58 +08:00
    其实可以 hook 嘛(不会破解竞品的 coder 不是一个好 coder, emmm). 不过这个东西移动端的也很无奈, 如果服务端去做了版本兼容其实还是可以避免这个情况(产品格外要求除外),但是站在服务端的角度也很无奈, 跑多个版本的 API 对于他们也是个灾难. 倒是觉得 @l12ab 他们的方法还可以, 至少不会太恶心人.
        27
    cnbattle   2018-01-23 18:39:18 +08:00 via Android
    公司得安卓一直是强更…
        28
    huclengyue   2018-01-23 18:45:31 +08:00 via Android
    难道 V2 上面大多数不是开发者吗?一般都是会保留 2 3 个版本的接口的,最新版本已经 20 了,你还用着第 10 个版本。接口天天在变,要是打不开,程序闪退,估计又要说 XX 垃圾,打开就闪退了。另外只要不是必须的 APP,其他的在强更的时候也有损失个别用户的准备。所以你不爽可以卸载
        29
    tadtung   2018-01-23 19:33:44 +08:00 via Android
    无解,除非你自己精简狗东 app 或者找别人破解版,,但京东我还真没见过
        30
    iwtbauh   2018-01-24 09:09:31 +08:00 via Android
    接口改动导致无法兼容这个问题,其实暗示着协议设计的有问题。如果一开始就将协议设计成具有良好扩展性或具有良好自描述能力的话,这种兼容问题所带来的痛苦感就会少很多,至少不应该存在几个小版本之间就不兼容的问题。
    很多小厂有时候为了赶进度,App 的协议竟然连一个版本号字段都没有,就算想在服务端兼容多个版本那也是不现实的,这时候除了强更还有什么办法 2333
        31
    bclerdx   2018-01-27 23:53:53 +08:00
    @Jameson1559 差不多该更新换代的,就更新吧。
    关于   ·   FAQ   ·   API   ·   我们的愿景   ·   广告投放   ·   感谢   ·   实用小工具   ·   951 人在线   最高记录 4385   ·  
    创意工作者们的社区
    World is powered by solitude
    VERSION: 3.9.8.3 · 18ms · UTC 19:10 · PVG 03:10 · LAX 12:10 · JFK 15:10
    ♥ Do have faith in what you're doing.
    沪ICP备16043287号-1